// Generated by LiveScript 1.5.0
(function(){
  var fs, path, ref$, log, logPad, errorList, autoFix, findError, findSim, logError, fix, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  ref$ = require('../log/log'), log = ref$.log, logPad = ref$.logPad;
  errorList = [
    {
      name: 'Typescript-is-not-a-Package',
      value: ['mostly is because you are installed typescript, but not linked it to the project', 'use "npm link typescript"']
    }, {
      name: 'require-not-found',
      value: ['mostly is because you are installed wired ghoti version', 'use "ghoti about"']
    }, {
      name: 'ts-is-not-a-Package',
      value: ['mostly is because you are installed typescript, but not linked it to the project', 'use "npm link typescript"']
    }, {
      name: 'Cannot-Cast-Null-to-Object-Webpack',
      value: ['mostly is because the version of typescript is too low to use awesome-typescript-loader', 'for win32 use "npm install -g typescript"', 'for unix use "sudo npm install -g typescript"']
    }, {
      name: 'Ghoti-have-no-Components-Configeration',
      value: ['mostly is because you are not in a ghoti project folder', 'go into a ghoti project folder']
    }, {
      name: 'Ghoti-have-no-Pages-Configeration',
      value: ['mostly is because you are not in a ghoti project folder', 'go into a ghoti project folder']
    }, {
      name: 'Ghoti-have-no-Lambdas-Configeration',
      value: ['mostly is because you are not in a ghoti project folder', 'go into a ghoti project folder']
    }, {
      name: 'Ghoti-have-no-Functions-Configeration',
      value: ['mostly is because you are not in a ghoti project folder', 'go into a ghoti project folder']
    }, {
      name: 'Ghoti-have-no-Funcs-Configeration',
      value: ['mostly is because you are not in a ghoti project folder', 'go into a ghoti project folder']
    }, {
      name: 'Ghoti-have-no-Features-Configeration',
      value: ['mostly is because you are not in a ghoti project folder', 'go into a ghoti project folder']
    }
  ];
  autoFix = function(ghoti, arg$){
    var env;
    if (arg$ != null) {
      env = arg$;
    }
    logPad('| Function is not supported yet :(, sorry', 1);
    logPad('| Please let me know if you have issue', 1);
    logPad('| Try "ghoti about"', 1);
  };
  findError = function(errorName){
    var i$, ref$, len$, i;
    for (i$ = 0, len$ = (ref$ = errorList).length; i$ < len$; ++i$) {
      i = ref$[i$];
      if (deepEq$(i.name, errorName, '===')) {
        return i;
      }
    }
    return null;
  };
  findSim = function(errorName){
    var sameList, i$, ref$, len$, i;
    sameList = [];
    for (i$ = 0, len$ = (ref$ = errorList).length; i$ < len$; ++i$) {
      i = ref$[i$];
      if (!deepEq$(i.name.toUpperCase().indexOf(errorName.toUpperCase()), -1, '===')) {
        sameList.push(i);
      }
    }
    return sameList;
  };
  logError = function(errorName, ghoti, arg$){
    var env, errorObj, list;
    if (arg$ != null) {
      env = arg$;
    }
    errorObj = findError(errorName);
    if (errorObj) {
      logPad('| Solution for "' + errorObj.name + '":', 1);
      errorObj.value.map(function(it){
        logPad('* ' + it, 2);
      });
    } else {
      list = findSim(errorName);
      if (list.length > 0) {
        logPad('| "' + errorName + '" is not in the list', 1);
        logPad('| Still, there are some similar error: ', 1);
        list.map(function(it){
          logPad('* ' + it.name, 2);
        });
        logPad('| Use "ghoti fix [issue name]" to checkout solution', 1);
        logPad('| You have to type full error name!', 1);
      } else {
        logPad('| Error "' + errorName + '" is not in the list', 1);
      }
      logPad('| Let me know your issue?', 1);
      logPad('| Try "ghoti about"', 1);
    }
  };
  fix = function(errorName, ghoti, whenDone, arg$){
    var env;
    if (arg$ != null) {
      env = arg$;
    }
    if (errorName) {
      logError(errorName, env);
    } else {
      autoFix(env);
    }
    whenDone();
  };
  out$.fix = fix;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
