// Generated by LiveScript 1.5.0
(function(){
  var fs, path, ref$, log, logPostInstall, parseAll, parseFile, lib, commonPath, switchRoot, removeTail, copyToPath, readFile, makeDir, logPath, copyInitReacursion, copyInit, init, slice$ = [].slice, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  ref$ = require('../log/log'), log = ref$.log, logPostInstall = ref$.logPostInstall;
  ref$ = require('./parser'), parseAll = ref$.parseAll, parseFile = ref$.parseFile;
  ref$ = require('../static/lib'), lib = ref$.lib, commonPath = ref$.commonPath;
  switchRoot = function(type, ghoti_root){
    var re;
    re = lib(type, ghoti_root);
    if (re) {
      return re;
    } else {
      return null;
    }
  };
  removeTail = function(filename){
    if (deepEq$(filename.substring(filename.length - 6, filename.length), '.ghoti', '===')) {
      return filename.substring(0, filename.length - 6);
    } else {
      return filename;
    }
  };
  copyToPath = function(root, data){
    if (deepEq$(root.substring(root.length - 6, root.length), '.ghoti', '===')) {
      return fs.writeFileSync(root.substring(0, root.length - 6), data, 'utf8');
    } else {
      return fs.writeFileSync(root, data, 'utf8');
    }
  };
  readFile = function(filename, root, vars){
    return parseFile(filename, fs.readFileSync(root, 'utf8'), vars);
  };
  makeDir = function(root){
    if (!fs.existsSync(root)) {
      return fs.mkdirSync(root);
    }
  };
  logPath = function(text, level){
    var space, i$;
    space = '';
    for (i$ = 0; i$ <= level; ++i$) {
      space += ' |';
    }
    return log(space + text);
  };
  copyInitReacursion = function(root, level, targetPath, beforeLength, vars){
    var files, eachFile;
    files = fs.readdirSync(root);
    eachFile = function(file){
      var pathname, stat, floatRoot;
      pathname = root + '/' + file;
      stat = fs.lstatSync(pathname);
      floatRoot = root.substring(beforeLength, root.length);
      if (stat.isDirectory()) {
        logPath('- ' + removeTail(file), level);
        makeDir(path.join(targetPath, floatRoot, file));
        return copyInitReacursion(root + '/' + file, level + 1, targetPath, beforeLength, vars);
      } else {
        logPath('* ' + removeTail(file), level);
        return copyToPath(path.join(targetPath, floatRoot, file), readFile(file, root + '/' + file, vars));
      }
    };
    return files.forEach(eachFile);
  };
  copyInit = function(type, targetPath, vars, root){
    var path_current;
    path_current = process.cwd();
    makeDir(path.join(path_current, targetPath));
    return copyInitReacursion(root, 0, path.join(path_current, targetPath), root.length, vars);
  };
  init = function(ghoti_root, type, targetPath, whenDone, env){
    var root;
    if (!targetPath) {
      log('init have to use format "ghoti init [type] [path]"');
      log('type could be any typename in list "ghoti list"');
      log('Try: "ghoti info init"');
      process.exit();
    }
    root = switchRoot(type, ghoti_root);
    return parseAll(type, targetPath, env, function(re, typesciprt){
      var count, common, i$, len$, i;
      log(' | @ Copying lib files');
      copyInit(type, targetPath, re, root.path);
      log(' | @ Copying common files');
      common = slice$.call(root.common);
      count = 0;
      if (re.open) {
        common.push(commonPath('license', ghoti_root));
      }
      for (i$ = 0, len$ = common.length; i$ < len$; ++i$) {
        i = common[i$];
        log(' | @ Common files chunk ' + count++);
        copyInit(type, targetPath, re, i);
      }
      logPostInstall(targetPath, type, typesciprt);
      whenDone();
    });
  };
  out$.init = init;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
