// Generated by LiveScript 1.5.0
(function(){
  var fs, path, ref$, log, logInline, version, exec, readline, checkTypescript, parseFile, getInput, parseAllIn, parseAll, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  ref$ = require('../log/log'), log = ref$.log, logInline = ref$.logInline;
  version = require('../static/static').version;
  exec = require('child_process').exec;
  readline = require('readline');
  checkTypescript = function(callback){
    var child;
    child = exec('tsc -v', function(err, stdout, stderr){
      if (err) {
        callback(false);
      } else {
        callback(true);
      }
    });
  };
  parseFile = function(filename, text, vars, arg$){
    var typescript, re, i;
    if (arg$ != null) {
      typescript = arg$;
    }
    re = text;
    re = re.replace(/\${\|version\|}/g, version);
    if (typescript) {
      re = re.replace(/\${\|typescript\|}/g, '"typescript": "^2.7.2",');
    } else {
      re = re.replace(/\${\|typescript\|}/g, '');
    }
    if (deepEq$(filename, 'package.json.ghoti', '===')) {
      if (vars.open) {
        re = re.replace(/\${\|private\|}/g, 'false');
        re = re.replace(/\${\|license\|}/g, 'SEE LICENSE IN LICENSE');
      } else {
        re = re.replace(/\${\|private\|}/g, 'true');
        re = re.replace(/\${\|license\|}/g, 'PRIVATE');
      }
    }
    for (i in vars) {
      switch (i) {
      case 'title':
        re = re.replace(/\${\|title\|}/g, vars.title);
        break;
      case 'description':
        re = re.replace(/\${\|description\|}/g, vars.description);
        break;
      case 'author':
        re = re.replace(/\${\|author\|}/g, vars.author);
      }
    }
    return re;
  };
  getInput = function(question, defaultText, callback){
    var intf, rl;
    intf = {
      input: process.stdin,
      output: process.stdout,
      terminal: false
    };
    rl = readline.createInterface(intf);
    if (deepEq$(defaultText, true, '===') || deepEq$(defaultText, false, '===')) {
      if (defaultText) {
        question += ' (Y/N, default: Y)';
      } else {
        question += ' (Y/N, default: N)';
      }
    } else {
      if (defaultText) {
        question += ' (default: ' + defaultText + ')';
      }
    }
    question += ' :\n=>> ';
    rl.question(question, function(answer){
      rl.close();
      if (deepEq$(defaultText, true, '===') || deepEq$(defaultText, false, '===')) {
        if (deepEq$(answer, '', '===')) {
          answer = defaultText;
        } else {
          if (deepEq$(answer, 'Y', '===')) {
            answer = true;
          } else if (deepEq$(answer, 'N', '===')) {
            answer = false;
          }
        }
      } else {
        if (deepEq$(answer, '', '===')) {
          answer = defaultText;
        }
      }
      callback(answer);
    });
  };
  parseAllIn = function(textList, vars){
    return vars;
  };
  parseAll = function(textList, targetPath, env, callback){
    return checkTypescript(function(typescriptExist){
      var vars, titleQuestionText;
      vars = {
        title: '',
        description: '',
        author: '',
        open: false
      };
      log('✒️  More about your awesome project~');
      titleQuestionText = 'Project Title';
      getInput(titleQuestionText, targetPath, function(title){
        var descriptionQuestionText;
        vars.title = title;
        descriptionQuestionText = 'Description of ' + vars.title;
        getInput(descriptionQuestionText, '', function(description){
          var authorQuestionText;
          vars.description = description;
          authorQuestionText = 'Author of ' + vars.title;
          getInput(authorQuestionText, '', function(author){
            var openQuestionText;
            vars.author = author;
            openQuestionText = 'Is ' + vars.title + ' is an open source project?';
            getInput(openQuestionText, false, function(open){
              vars.open = open;
              return callback(parseAllIn(textList, vars), typescriptExist);
            });
          });
        });
      });
    });
  };
  out$.parseFile = parseFile;
  out$.parseAll = parseAll;
  out$.checkTypescript = checkTypescript;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
