// Generated by LiveScript 1.5.0
(function(){
  var fs, path, ref$, log, logPad, updateConfig, ghotiPageClassName, ghotiPageFileName, ghotiPageExport, readFile, comImport, page, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  ref$ = require('../log/log'), log = ref$.log, logPad = ref$.logPad;
  updateConfig = require('../func/config').updateConfig;
  ghotiPageClassName = function(name){
    return "PageGhoti" + name.substring(0, 1).toUpperCase() + name.substring(1, name.length);
  };
  ghotiPageFileName = function(name){
    return name + ".page";
  };
  ghotiPageExport = function(name){
    return "    " + ghotiPageClassName(name) + " as " + name;
  };
  readFile = function(root, name, ghoti){
    var re;
    re = fs.readFileSync(root, 'utf8').toString();
    re = re.replace(/\${\|page\|}/g, ghotiPageClassName(name));
    re = re.replace(/\${\|author\|}/g, ghoti.author || "unknown");
    return re;
  };
  comImport = function(ghoti){
    var re;
    if (!Boolean(ghoti.pages)) {
      log('ERROR, ghoti have no pages configeration');
      log('Try to fix it: "ghoti fix"');
      process.exit();
    }
    re = ghoti.pages.map(function(it){
      return "import " + ghotiPageClassName(it) + " from './" + ghotiPageFileName(it) + "';";
    }).join("\r\n");
    re += "\r\n";
    re += "export {\r\n" + ghoti.pages.map(function(it){
      return ghotiPageExport(it) + ",";
    }).join("\r\n") + "\r\n};";
    return re;
  };
  page = function(root, targetPath, name, ghoti, whenDone, env){
    var i$, ref$, len$, i, target, importTarget, data;
    if (!Boolean(ghoti.pages)) {
      log('ERROR, ghoti have no pages configeration');
      log('Try to fix it: "ghoti fix"');
      process.exit();
    }
    for (i$ = 0, len$ = (ref$ = ghoti.pages).length; i$ < len$; ++i$) {
      i = ref$[i$];
      if (deepEq$(i, name, '===')) {
        log('| ERROR: page "' + name + '" is already exist');
        log('| try "ghoti status" to see page list');
        whenDone();
        process.exit();
      }
    }
    target = path.join(targetPath, "src", "page", name + ".page.tsx");
    importTarget = path.join(targetPath, "src", "page", "import.ts");
    data = readFile(path.join(root, "lib", "react", "page", "page.tsx.ghoti"), name, ghoti);
    ghoti.pages.push(name);
    log('| update .ghoticonfig file');
    updateConfig(ghoti);
    log('| update import setting');
    fs.writeFileSync(importTarget, comImport(ghoti), 'utf8');
    log('| initialize paging script');
    fs.writeFileSync(target, data, 'utf8');
  };
  out$.page = page;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
